
/*  Programmi põhieesmärk on lugeda täisarvude maatriksis, 
 * leida maatriksi esimese ja viimase rea jagatis ning seejärel
 *  kuvada algmaatriks ja massiiv, mis sisaldab
 *  esimese ja viimase rea jagatist.    */
#include <stdio.h>
	// Prototüübid.
int kusi_int(char [], int, int);
void sisesta_maatrix(int, int y, int[][y]);
void leia_jagatised_readest(int, int y, int [][y], float [], int, int);
void näita_maatrix(int, int s, int[][s]);
void näita_masiiv(int, float []);

int main(void){
	int suurus_x, suurus_y, k;
	// Sisestus.
	suurus_x = kusi_int("Sisesta x (2-10): ", 2, 10);
	suurus_y = kusi_int("Sisesta y (2-10): ", 2, 10);
		// Pea meeles, et masiivi luua, peab selle suurust teadma!
	int maatrix[suurus_x][suurus_y];
	float jagatised[suurus_y];
	sisesta_maatrix(suurus_x, suurus_y, maatrix);
	// Protsess.
	k = suurus_x - 1;
	leia_jagatised_readest(suurus_x, suurus_y, maatrix, jagatised, 0, k);
	// Väljastus.
	näita_maatrix(suurus_x, suurus_y, maatrix);
	näita_masiiv(suurus_y, jagatised);
	return 0;
}

// Funktsioonid.

/*
Tee mulle C funktsioon prototüübiga "int kusi_int(char [], int, int);", 
funktsioon tagastab int. char [] on küsimus, mida funktsioon kasutajalt küsib. 
Järgnevad int, int on miinimum väärtus ja maksimum väärtus, 
mida saab kasutaja sisestada.
*/
int kusi_int(char question[], int min, int max) {
    int value;
    int valid = 0;

    while (!valid) {
        printf("%s", question);
        if (scanf("%d", &value) != 1) {
            // Kui sisend ei ole täisarv, siis puhastame sisendi ja küsime uuesti
            printf("Palun sisestage kehtiv täisarv.\n");
            while(getchar() != '\n'); // Puhastame sisendi
        } else if (value < min || value > max) {
            // Kui sisend ei ole vahemikus [min, max], siis küsime uuesti
            printf("Sisestage arv vahemikus [%d, %d].\n", min, max);
        } else {
            // Kehtiv sisend
            valid = 1;
        }
    }

    return value;
}

/*
Tee mulle fnktsioon prototüübiga "void sisesta_maatrix(int, int y, int[][y]);"
Esimesed sisendid on maatriksi pikkus ja laius. int [][y] on masiiv.
Funktsioon küsib kasutajalt iga maatrixi väärtust.
 */
void sisesta_maatrix(int m, int y, int matrix[][y]) {
    // Küsime kasutajalt maatrixi väärtusi
    printf("Sisestage maatrixi väärtused (%d rida ja %d veergu):\n", m, y);
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < y; j++) {
            printf("Väärtus [%d][%d]: ", i, j);
            scanf("%d", &matrix[i][j]);
        }
    }
}

/*
Tee mulle c keeles funktsioon prototüübiga 
"void leia_jagatised_readest(int, int y, int [][y], float [], int, int);".
Esimesed int, int y on järgnevate maatrixi pikkus ja laius, ning tulemus
masiivi pikkus. int [][y] on sisestattud maatrix ja float [] on massiiv, 
mis hoiustab tulemusi. järgnev int, int on rida, mida jagatakse teise reaga.
funktsioon jagab igat elementi maatrixi ühes reas teise reaga ja
sisestab float [] masiivi.
*/
void leia_jagatised_readest(int m, int y, int matrix[][y], float results[], int row1, int row2) {
    // Kontrollime, et antud read on kehtivad
    if (row1 < 0 || row1 >= m || row2 < 0 || row2 >= m) {
        printf("Vigased read: %d ja %d\n", row1, row2);
        return;
    }

    // Jagame iga elemendi row1-st vastava elemendiga row2-st
    for (int j = 0; j < y; j++) {
        if (matrix[row2][j] != 0) { // Kontrollime, et jagaja ei ole null
            results[j] = (float)matrix[row1][j] / matrix[row2][j];
        } else {
            printf("Jagamine nulliga! Row1: %d, Row2: %d, Column: %d\n", row1, row2, j);
            results[j] = 0; // Võime määrata tulemuseks 0, kui jagame nulliga
        }
    }
}

/*
Tee c funktsioon prototüübiga "void näita_maatrix(int, int s, int[][s]);".
Esimesed väärtused on maatrixi suurused. int[][s] on maatrix.
Funktsioon prindib maatrixi.
*/
void näita_maatrix(int m, int s, int matrix[][s]) {
    // Väljasta maatrix
    printf("Maatrix (%d rida ja %d veergu):\n", m, s);

    for (int i = 0; i < m; i++) {
        for (int j = 0; j < s; j++) {
            printf("%d ", matrix[i][j]);
        }
        printf("\n"); // Uus rida pärast iga maatrixi rida
    }
}

/*
Tee c funktsioon prototüübiga "void näita_masiiv(int, float []);".
Esimesed väärtus on masiivi suurus. int[] on masiiv.
Funktsioon prindib masiivi.
*/
void näita_masiiv(int suurus, float masiiv[]) {
    // Väljasta masiiv
    printf("Masiiv (%d elementi):\n", suurus);
    
    for (int i = 0; i < suurus; i++) {
        printf("%f ", masiiv[i]);
    }
    printf("\n"); // Uus rida pärast masiivi väljundit
}

// 1 3 5
// 2 4 6

// 1 2
// 3 4
// 5 6
